--------------------------------------------------------------------------------
--------------------------------------------------------------------------------
--Module       : Data.Category
--Author       : Daniel Schüssler
--License      : BSD3
--Copyright    : Daniel Schüssler
--
--Maintainer   : Daniel Schüssler
--Stability    : Experimental
--Portability  : Uses various GHC extensions
--
--------------------------------------------------------------------------------
--Description  : 
--------------------------------------------------------------------------------
--------------------------------------------------------------------------------



{-# LANGUAGE TypeOperators #-}
{-# LANGUAGE FlexibleInstances #-}
{-# LANGUAGE TypeSynonymInstances #-}
{-# LANGUAGE TypeFamilies #-}
{-# LANGUAGE NoMonomorphismRestriction #-}
{-# LANGUAGE ScopedTypeVariables #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE GADTs #-}
{-# LANGUAGE RankNTypes #-}

-- | This module is a stub!
module Data.Category where

import Type.Set
import Type.Dummies
import Type.Function
import Type.Logic
import Data.Type.Equality
import Control.Monad
    

-- | Category with type-level set of objects and type-level /hom/ function, but value-level composition and value-level definition of identity functions.
data Cat ob hom =
    Cat {
      homIsFun :: ((ob :×: ob) :~>: Univ) hom
    , getId :: forall a aa. ((a,a), aa) :∈: hom -> aa
    -- | Composition
    , cc :: forall a b c bc ab ac. 
           ((b,c), bc) :∈: hom ->
           ((a,b), ab) :∈: hom ->
           ((a,c), ac) :∈: hom ->

               bc -> ab -> ac
    }
                
hask :: Cat Univ HaskFun
hask = Cat (extendCod haskFunIsFun auto)
       (\HaskFun -> id)
       (\HaskFun HaskFun HaskFun -> (.))
       
kleisli :: Monad m => Cat Univ (KleisliHom m)
kleisli = Cat (extendCod kleisliHomIsFun auto)
          (\KleisliHom -> return)
          (\KleisliHom KleisliHom KleisliHom -> (<=<))

idEx :: Cat ob hom -> ob a -> (forall aa. ((a,a),aa) :∈: hom -> aa -> r) -> r
idEx cat a k = case total (homIsFun cat) (a :×: a) of
                 ExSnd faa -> k faa (getId cat faa)
                             
-- idAuto :: forall ob hom a aa. Fact (((a, a), aa) :∈: hom) => Cat ob hom -> aa
-- -- idAuto cat _ = idn cat auto
-- idAuto cat _ = case total (homIsFun cat) 

idAuto :: forall a aa hom ob. (Fact (((a, a), aa) :∈: hom)) => Cat ob hom -> aa
idAuto cat = getId cat (auto :: ((a,a),aa) :∈: hom)
             
-- ccAuto :: forall a b c bc ab ac hom ob.
--      (Fact (((b, c), bc) :∈: hom),
--       Fact (((a, b), ab) :∈: hom),
--       Fact (((a, c), ac) :∈: hom)) =>
--      Cat ob hom -> bc -> ab -> ac
ccAuto cat = cc cat auto auto auto

test :: a -> a
test = idAuto hask


test2 :: (b -> c) -> (a -> b) -> a -> c
test2 = ccAuto hask
        

test3 :: forall m a. Monad m => a -> m a
test3 = idAuto kleisli
      
-- foo :: forall a. a -> a
-- foo = idEx hask (Univ :: Univ a) go
--       where
--          go :: (((a, a), aa) :∈: HaskFun) -> aa -> (a -> a)
--          go HaskFun x = x

       
-- data Functor omap
